package mdutils

import (
	dag "gitlab.dms3.io/dms3/go-merkledag"

	bsrv "gitlab.dms3.io/dms3/go-blockservice"
	ds "gitlab.dms3.io/dms3/go-datastore"
	dssync "gitlab.dms3.io/dms3/go-datastore/sync"
	blockstore "gitlab.dms3.io/dms3/go-dms3-blockstore"
	offline "gitlab.dms3.io/dms3/go-dms3-exchange-offline"
	ld "gitlab.dms3.io/dms3/go-ld-format"
)

// Mock returns a new thread-safe, mock DAGService.
func Mock() ld.DAGService {
	return dag.NewDAGService(Bserv())
}

// Bserv returns a new, thread-safe, mock BlockService.
func Bserv() bsrv.BlockService {
	bstore := blockstore.NewBlockstore(dssync.MutexWrap(ds.NewMapDatastore()))
	return bsrv.New(bstore, offline.Exchange(bstore))
}
